let btn = document.querySelector(".button");
let qr_code_element = document.querySelector(".qr-code");

btn.addEventListener("click", () => {
  let user_input = document.querySelector("#input_text").value;
  let qr_code_name = document.querySelector("#qr_code_name").value;
  if (isValidURL(user_input) && isValidQRName(qr_code_name)) {
    if (qr_code_element.childElementCount == 0) {
      generate(user_input, qr_code_name);
    } else {
      qr_code_element.innerHTML = "";
      generate(user_input, qr_code_name);
    }
  } else {
    console.log("not valid input");
    qr_code_element.style = "display: none";
  }
});
 
function generate(user_input, qr_code_name) {
  let randomString = "";
  for (let i = 0; i < 6; i++) {
    randomString += String.fromCharCode(Math.floor(Math.random() * 26) + 97);
  }
  let filename = qr_code_name + randomString + ".php";
  let phpContent = "header(\"Location: " + user_input + "\", true, 301);";
  createFileOnServer(filename, phpContent);
  var qrcode = new QRCode(qr_code_element, {
    text: `http://qrcode.vizeo.eu/` + filename,
    width: 600,
    height: 600,
    colorDark: "#151c37", 
    colorLight: "#fff",
    correctLevel: QRCode.CorrectLevel.M
  });

  let qr_code_img = document.querySelector(".qr-code img");
  let qr_code_canvas = document.querySelector("canvas");


let qr_code_name_element = document.createElement("p");
qr_code_name_element.style = "text-align: center; font-weight: bold; font-size: 22px; color: black; padding: 15px;";
if (qr_code_name !== "undefined") {
  qr_code_name_element.innerHTML = qr_code_name;
  qr_code_element.appendChild(qr_code_name_element);
}
    
  if (qr_code_img.getAttribute("src") == null) {
    setTimeout(() => {
      download_link.setAttribute("href", `${qr_code_canvas.toDataURL()}`);
    }, 300);
  } else {
    setTimeout(() => {
      download_link.setAttribute("href", `${qr_code_img.getAttribute("src")}`);
    }, 300);
  }
}

function createFileOnServer(filename, content) {
  fetch("php.php", {
    method: "POST",
    body: JSON.stringify({
      filename: filename,
      content: content
    }),
    headers: {
      "Content-Type": "application/json"
    }
  })
    .then(response => response.text())
    .then(response => console.log(response))
    .catch(error => console.log(error));
}

function isValidURL(url) {
  // A mettre a jour selon vos besoins
  let pattern = new RegExp('^(https?:\\/\\/)?'+ // protocol
    '((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.)+[a-z]{2,}|'+ // domain name
    '((\\d{1,3}\\.){3}\\d{1,3}))'+ // OR ip (v4) address
    '(\\:\\d+)?(\\/[-a-z\\d%_.~+]*)*'+ // port and path
    '(\\?[;&a-z\\d%_.~+=-]*)?'+ // query string
    '(\\#[-a-z\\d_]*)?$','i'); // fragment locator
  return pattern.test(url);
}

function isValidQRName(name) {
  // A mettre a jour selon vos besoins
  let pattern = /^[a-zA-Z0-9]+$/;
  return pattern.test(name);
}

generate({
  value: ""
});